## magics++ 2.29.2

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF

# TODO:
#  * fix python module generation Magics.py to __init__.py
#  * cpack ecbuild/cmake macros into tar.gz
#  * unit tests check that certain files are produced and not empty
#  * pkg-config needed for metview

# Missing dependencies:
#   * ghostscript ( is it really needed? -- to confirm )

cmake_minimum_required( VERSION 2.8.11 FATAL_ERROR )

project( magics CXX )

# make sure that the header files are installed into include/magics
# note that this needs to be done before ecbuild_declare_project()
# to ensure that the ecbuild header files are also put there
# note also that we need to CACHE this so that ecbuild_declare_project() does not overwrite it
set(MAGICS_INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")
set(INSTALL_INCLUDE_DIR include/magics CACHE PATH "Magics installation directory for header files")

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.9 )

###############################################################################
# some variables of this project

ecbuild_add_option( FEATURE ECCODES DESCRIPTION "" DEFAULT OFF )

if( HAVE_ECCODES )
  ecbuild_use_package( PROJECT eccodes VERSION 0.14 REQUIRED )
  set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
  set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
  set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
  set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )
else()
  ecbuild_use_package(PROJECT grib_api VERSION 1.14.6 REQUIRED)
endif()


# grib_api is required for now
set( HAVE_GRIB 1 )

ecbuild_add_option( FEATURE BUFR
                    DEFAULT ON
                    DESCRIPTION "BUFR support"
                    REQUIRED_PACKAGES "PROJECT libemos VERSION 4.0.5" )

ecbuild_add_option( FEATURE ODB
                    DEFAULT ON
                    DESCRIPTION "ODB support"
                    REQUIRED_PACKAGES 
            "PROJECT odb_api VERSION 0.10.2"
						"PROJECT eckit   VERSION 0.9.0" )

ecbuild_add_option( FEATURE CAIRO
                    DEFAULT ON
                    DESCRIPTION "cairo support[png/jpeg]"
                    REQUIRED_PACKAGES PangoCairo )

ecbuild_add_option( FEATURE GEOTIFF
                    DEFAULT OFF
                    DESCRIPTION "geotiff support [implies cairo]"
                    CONDITION HAVE_CAIRO
                    REQUIRED_PACKAGES GeoTIFF )

ecbuild_add_option( FEATURE NETCDF
                    DEFAULT ON
                    DESCRIPTION "enable netcdf support"
                    REQUIRED_PACKAGES "NetCDF 4 COMPONENTS C CXX" )

ecbuild_add_option( FEATURE SPOT
                    DEFAULT OFF
                    DESCRIPTION "enable spot support"
                    REQUIRED_PACKAGES "PROJECT spot" )

ecbuild_add_option( FEATURE PYTHON
                    DEFAULT ON
                    DESCRIPTION "enable python interface"
                    REQUIRED_PACKAGES Python SWIG NumPy )

if( HAVE_PYTHON )
   include(UseSWIG)
endif()

ecbuild_add_option( FEATURE FORTRAN
                    DEFAULT ON
                    DESCRIPTION "enable Fortran interface" )

if( HAVE_FORTRAN )
	ecbuild_enable_fortran( REQUIRED )
endif()

ecbuild_add_option( FEATURE METVIEW
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface" )

ecbuild_add_option( FEATURE METVIEW_NO_QT
                    DEFAULT OFF
                    DESCRIPTION "enable Metview interface without Qt" )

ecbuild_add_option( FEATURE QT5
                    DEFAULT OFF
                    DESCRIPTION "use Qt5 instead of version 4" )

ecbuild_add_option( FEATURE PNG
                    DESCRIPTION "support for PNG decoding/encoding"
                    DEFAULT ON
                    REQUIRED_PACKAGES PNG
)

if( HAVE_PNG )
    add_definitions( ${PNG_DEFINITIONS} )
endif()

option( BUILD_SHARED_LIBS  "Set to BOTH to build static library in addition to shared"  ON )
option( ENABLE_REGRESSION        "Internal use only: enable regression test"  OFF  )
option( ENABLE_REGRESSION_UPLOAD "Internal use only : enable upload of reference image"  OFF  )

set( MAGICS_NAME          "Magics" )
set( MAGICS_EXCEPTION     "ON" )
set( MAGICS_SITE          "ecmwf" )
set( MAGICS_INSTALL_PATH  ${CMAKE_INSTALL_PREFIX} )

set( MAGICS_REFERENCE_VERSIONS            "2.29.1" )
set( MAGICS_HTML_ROOT        "${CMAKE_BINARY_DIR}/regression/html")
file(MAKE_DIRECTORY ${MAGICS_HTML_ROOT} )

set( MAG_PYTHON_PATH ${CMAKE_BINARY_DIR}/python )

###############################################################################
# projects

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )

#ecbuild_add_cxx_flags("-gdwarf-2")
ecbuild_add_c_flags("-std=c99")

### Metview and Qt

if(HAVE_METVIEW AND HAVE_METVIEW_NO_QT)
    message(FATAL_ERROR "Do not set both HAVE_METVIEW and HAVE_METVIEW_NO_QT - only set one. You may have to remove your CMakeCache.txt to clear these settings.")
endif()

set( qt no )
set( metview no )

if( HAVE_METVIEW_NO_QT )
	set( metview yes )
	unset(MAGICS_ONLY)
endif()

if( HAVE_METVIEW )
    set ( metview yes)
    message(STATUS "TESTING for Metview ...")
    unset(MAGICS_ONLY)

    if( HAVE_QT5 )
      find_package(Qt5Widgets REQUIRED)
      if( Qt5Widgets_FOUND )
          message(STATUS "Qt5 was found ... ${Qt5Widgets_VERSION_STRING}")
          include_directories(${Qt5Widgets_INCLUDE_DIRS})
          set( MAGICS_QT 1)
          set( MAGICS_QT5 1)
          set( qt yes)
          add_definitions( -DMAGICS_QT5 )
      else()
          message(FATAL_ERROR "Qt5 was NOT found ...")
      endif()
    else()
    find_package(Qt4 4.4.3 REQUIRED QtCore QtGui QtXml )
    if( QT_FOUND )
		  include( ${QT_USE_FILE} )
		  set( MAGICS_QT 1)
		  set( qt yes)
    endif()
    endif()
endif()

ecbuild_declare_project()

###############################################################################
# find extra packages

set( CMAKE_THREAD_PREFER_PTHREAD 1 )
find_package( Threads ) 

# set(Boost_USE_STATIC_LIBS        ON)
# set(Boost_NO_SYSTEM_PATHS        ON)
# set(Boost_USE_MULTITHREADED      ON)
#ecbuild_add_extra_search_paths( boost )

find_package( Boost 1.49.0 REQUIRED)
find_package( Proj4 REQUIRED )
find_package( EXPAT REQUIRED )

###############################################################################
# contents

set( MAGICS_TPLS grib_api spot EXPAT NetCDF PNG Proj4 libemos )

set( MAGICS_INCLUDE_DIRS 
     ${CMAKE_CURRENT_SOURCE_DIR}/src 
     ${CMAKE_BINARY_SOURCE_DIR}/src 
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common 
     ${CMAKE_CURRENT_BINARY_DIR}/src/params 
     ${CMAKE_CURRENT_BINARY_DIR}/src 
     ${CMAKE_CURRENT_SOURCE_DIR}/src/common  
     ${CMAKE_CURRENT_SOURCE_DIR}/src/basic
     ${CMAKE_CURRENT_SOURCE_DIR}/src/web
     ${CMAKE_CURRENT_SOURCE_DIR}/src/visualisers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/drivers/MgQ
     ${CMAKE_CURRENT_SOURCE_DIR}/src/eckit_readers
     ${CMAKE_CURRENT_SOURCE_DIR}/src/decoders
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib
     ${CMAKE_CURRENT_SOURCE_DIR}/src/terralib/kernel
     ${CMAKE_CURRENT_SOURCE_DIR}/src/libMagWrapper
     ${Boost_INCLUDE_DIRS} )

if( HAVE_CAIRO )
  list( APPEND MAGICS_TPLS PangoCairo )
  list( APPEND MAGICS_INCLUDE_DIRS ${PANGOCAIRO_INCLUDE_DIRS} )
endif()

if( HAVE_ODB )
  list( APPEND MAGICS_TPLS odb_api )
  list( APPEND MAGICS_INCLUDE_DIRS
        ${CMAKE_CURRENT_SOURCE_DIR}/src/oda
        ${ODB_API_INCLUDE_DIRS}
		${ECKIT_INCLUDE_DIRS} )
endif()

set( MAGICS_LIBRARIES    MagPlus )

foreach( _tpl ${MAGICS_TPLS} )
    string( TOUPPER ${_tpl} TPL )
    if( NOT ${TPL} STREQUAL "LIBEMOS" ) # don't add libemos definitions
    list( APPEND MAGICS_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS}  )
    endif()
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} )
endforeach()

if( HAVE_BUFR )
	list( APPEND MAGICS_EXTRA_DEFINITIONS   fortfloat=double fortint=int )
    ecbuild_find_fortranlibs()
	list( APPEND MAGICS_EXTRA_LIBRARIES ${FORTRAN_LIBRARIES} )
endif()
if( WITH_QT_DEBUG )
	list( APPEND MAGICS_EXTRA_DEFINITIONS QT_NO_DEBUG_OUTPUT )
endif()

if( MAGICS_QT )
  if( MAGICS_QT5 )
    list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${Qt5Widgets_INCLUDE_DIR} )
    list( APPEND MAGICS_EXTRA_LIBRARIES     ${Qt5Widgets_LIBRARIES} )
  else()
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${QT_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES     ${QT_LIBRARIES} )
endif()
endif()

if( HAVE_GEOTIFF )
	list( APPEND MAGICS_EXTRA_INCLUDE_DIRS  ${GEOTIFF_INCLUDE_DIR} )
	list( APPEND MAGICS_EXTRA_LIBRARIES  ${GEOTIFF_LIBRARY} )
  list( APPEND MAGICS_EXTRA_DEFINITIONS HAVE_GEOTIFF )
endif()

list( APPEND MAGICS_EXTRA_LIBRARIES     ${CMAKE_THREAD_LIBS_INIT} )

ecbuild_debug("MAGICS_EXTRA_DEFINITIONS  => ${MAGICS_EXTRA_DEFINITIONS}")
ecbuild_debug("MAGICS_EXTRA_INCLUDE_DIRS => ${MAGICS_EXTRA_INCLUDE_DIRS}")
ecbuild_debug("MAGICS_EXTRA_LIBRARIES    => ${MAGICS_EXTRA_LIBRARIES}")

# set_directory_properties( PROPERTIES COMPILE_DEFINITIONS "${ECKIT_DEFINITIONS}" )
get_directory_property( MAGICS_DEFINITIONS COMPILE_DEFINITIONS )

include_directories( ${MAGICS_INCLUDE_DIRS} ${MAGICS_EXTRA_INCLUDE_DIRS} )

# scripts
add_subdirectory( tools )

# source files
add_subdirectory( src )

# shared files
add_subdirectory( share )

# python interface 
add_subdirectory( python )

# apps directory
add_subdirectory( apps )

# Test directory
add_subdirectory( test )
if( ENABLE_REGRESSION )
    add_subdirectory( regression )
endif()

# Directories not need in the distribution tar ball!
ecbuild_add_resources( TARGET old_src DONT_PACK_DIRS src/MvObs src/libTable src/xml src/terralib/functions)
ecbuild_add_resources( TARGET bamboo DONT_PACK_DIRS bamboo)
ecbuild_add_resources( TARGET old_ressources 
		DONT_PACK_DIRS tools/versioncmp 
		tools/regression 
		regression
		docs
		toolsjs
		test/old
		tools/xml 
		tools/use_scripts
		tools/versioncmp_folders)

ecbuild_add_resources( TARGET internal 
		DONT_PACK configure.lxab
		configure.local
		configure.ecgb
		configure.ecmwf
)

############################################################################################
# finalize

set( MAGICS_DESCRIPTION "Multi-platform meteorological graphics library" )
set( MAGICS_URL "https://software.ecmwf.int/wiki/display/MAGP/Magics" )
ecbuild_pkgconfig()

ecbuild_install_project( NAME Magics )

ecbuild_print_summary()

=== src/CMakeLists.txt ===
###############################################################################

configure_file( magics_config.h.in  magics_config.h  )

install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/magics_config.h  DESTINATION ${INSTALL_INCLUDE_DIR})

###############################################################################


function( add_metview_definition_file )
   
    set( single_value_args ACTION BASENAME FILE ) 
    cmake_parse_arguments( _p "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )
     
    add_custom_command( 
            OUTPUT ${_p_BASENAME}Def ${_p_BASENAME}Rules
            COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../../tools/xml2mv.py ${CMAKE_CURRENT_SOURCE_DIR} ${_p_FILE}  ${_p_BASENAME}Def ${_p_ACTION} ${_p_BASENAME}Rules
            DEPENDS ${_p_FILE}
      )
     
     
    add_custom_target( ${_p_BASENAME} ALL DEPENDS ${_p_BASENAME}Def)
    install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Def ${CMAKE_CURRENT_BINARY_DIR}/${_p_BASENAME}Rules DESTINATION ${INSTALL_DATA_DIR}/../magics/metview)

endfunction(add_metview_definition_file)

add_subdirectory( params )



foreach( file ${magics_xmls} )

      get_filename_component( path     ${file} PATH   )
      get_filename_component( basefile ${file} NAME_WE )

      set( ouputfiles ${path}/${basefile}Attributes.h ${path}/${basefile}Attributes.cc )
      
      # generate the code
      add_custom_command( 
            OUTPUT  ${ouputfiles}
            COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2cc_new.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
            DEPENDS ${file}
      )

      set_source_files_properties( ${basefile}Attributes.h  GENERATED )
      set_source_files_properties( ${basefile}Attributes.cc GENERATED )

      list( APPEND magics_params_srcs ${ouputfiles} )

endforeach()
     
if ( metview )

	foreach( file ${metview_xmls} )
	      get_filename_component( path     ${file} PATH   )
          get_filename_component( basefile ${file} NAME_WE )
		  
		  set( metviewfiles ${path}/${basefile}Wrapper.h ${path}/${basefile}Wrapper.cc )
		  
		  
		# generate the code
		  add_custom_command( 
				OUTPUT  ${metviewfiles}
				COMMAND ${PERL_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../tools/xml2mv.pl ${CMAKE_CURRENT_SOURCE_DIR}/${file} ${CMAKE_CURRENT_BINARY_DIR}/params nosubdir
				DEPENDS ${file}
			)

		  set_source_files_properties( ${basefile}Wrapper.h  GENERATED )
          set_source_files_properties( ${basefile}Wrapper.cc GENERATED )
          list( APPEND metview_wrappers_srcs ${metviewfiles} )
      endforeach()

     if(qt)
        SET(qt_drivers_HEADERS drivers/MgQ/MgQPlotScene.h)
        if( MAGICS_QT5 )
          QT5_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        else()
          QT4_WRAP_CPP(qt_drivers_HEADERS_MOC ${qt_drivers_HEADERS})
        endif()        
        list( APPEND drivers_srcs  drivers/MgQ/MgQPlotScene.cc  ${qt_drivers_HEADERS_MOC})
     endif()
endif()


add_custom_target( magics_params DEPENDS ${magics_params_srcs} )
add_custom_target( mv_params DEPENDS ${metview_wrappers_srcs} )
###############################################################################

add_subdirectory( common )
add_subdirectory( basic )
add_subdirectory( web )
add_subdirectory( visualisers )
add_subdirectory( drivers )
add_subdirectory( decoders )
add_subdirectory( terralib )
add_subdirectory( eckit_readers )

if( metview )
	add_subdirectory( libMagWrapper )
endif()

if( HAVE_ODB )
	add_subdirectory( oda )
endif()

include_directories( ${CMAKE_CURRENT_SOURCE_DIR}/common )

ecbuild_add_library( TARGET    MagPlus
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs} 
                        ${common_srcs} 
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${terralib_srcs} 
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS} MAGICS_EXCEPTION=on
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                     TYPE SHARED )

ecbuild_add_library( TARGET      MagPlusSingle
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

ecbuild_add_library( TARGET      MagPlusDouble
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlus
                     TYPE        SHARED )

if ( BUILD_SHARED_LIBS STREQUAL "BOTH" )
ecbuild_add_library( TARGET    MagPlusStatic
                     DEPENDS   magics_params
                     SOURCES
                        magics.h
                        ${magics_params_srcs} 
                        ${common_srcs} 
                        ${basic_srcs}
                        ${web_srcs}
                        ${visualisers_srcs}
                        ${eckit_srcs}
                        ${drivers_srcs}
                        ${qt_srcs}
                        ${decoders_srcs}
                        ${terralib_srcs} 
                        ${odb_srcs}
                     TEMPLATES
                        ${common_templates}
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}  
                     LIBS
                        ${MAGICS_EXTRA_LIBRARIES} 
                     TYPE STATIC
                     OUTPUT_NAME MagPlus )

ecbuild_add_library( TARGET      MagPlusSingleStatic 
                     SOURCES     MagicsSingle.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusSingle )

ecbuild_add_library( TARGET      MagPlusDoubleStatic
                     SOURCES     MagicsDouble.cc
                     LIBS        MagPlusStatic
                     TYPE        STATIC
                     OUTPUT_NAME MagPlusDouble )

endif()

if( metview )
 include_directories(  ${CMAKE_CURRENT_SOURCE_DIR} 
                        ${CMAKE_CURRENT_BINARY_DIR} 
                        ${CMAKE_CURRENT_BINARY_DIR}/params 
                        ${CMAKE_CURRENT_SOURCE_DIR}/common  
                        ${CMAKE_CURRENT_SOURCE_DIR}/basic
                        ${CMAKE_CURRENT_SOURCE_DIR}/web
                        ${CMAKE_CURRENT_SOURCE_DIR}/visualisers
                        ${CMAKE_CURRENT_SOURCE_DIR}/drivers
                        ${CMAKE_CURRENT_SOURCE_DIR}/decoders
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib
                        ${CMAKE_CURRENT_SOURCE_DIR}/terralib/kernel 
                        ${CMAKE_CURRENT_SOURCE_DIR}/libMagWrapper )
  

                        
  ecbuild_add_library( TARGET    MagWrapper
                     DEPENDS   mv_params magics_params
                     SOURCES
                        magics.h
                        ${metview_srcs} 
                        ${metview_wrappers_srcs} 
                     DEFINITIONS
                        ${MAGICS_EXTRA_DEFINITIONS}                   
                    LIBS
                        ${MAGICS_EXTRA_LIBRARIES}
                    TYPE STATIC		
                    )
   list( APPEND attributes_include
				OutputHandlerAttributes.h 
				FortranRootSceneNodeAttributes.h  
                BinningObjectAttributes.h
                GribDecoderAttributes.h
                DateGribLoopStepAttributes.h
                GribLoopAttributes.h
                GeoRectangularProjectionAttributes.h
                LegendVisitorAttributes.h
				XmlRootNodeAttributes.h 
				WrepRootNodeAttributes.h
                ContinuousLegendMethodAttributes.h
                HistogramLegendMethodAttributes.h
                XmlBasicNodeAttributes.h
                ImagePlottingAttributes.h
                LookupTableModeAttributes.h
                FixedTableModeAttributes.h
				)
   if(qt)
     list(APPEND attributes_include
                 QtDriverAttributes.h)
   endif()

   install( FILES terralib/kernel/TeProjection.h
				   terralib/kernel/TeCoord2D.h 
				   terralib/kernel/TeDefines.h 
				   terralib/kernel/TePrecision.h 
				   terralib/kernel/TeSingleton.h 
				   terralib/kernel/TeDatum.h 
				   terralib/kernel/TeUtils.h
				   
				   
				   DESTINATION ${INSTALL_INCLUDE_DIR})
   install( FILES VectorOfPointers.h  DESTINATION ${INSTALL_INCLUDE_DIR})
   foreach( file ${attributes_include} )
     install( FILES ${CMAKE_CURRENT_BINARY_DIR}/params/${file}  DESTINATION ${INSTALL_INCLUDE_DIR})
   endforeach()
   install( FILES ${metview_include} DESTINATION ${INSTALL_INCLUDE_DIR})
endif()
install( FILES magics.h  DESTINATION ${INSTALL_INCLUDE_DIR})

=== python/Magics/CMakeLists.txt ===
if( HAVE_PYTHON )

  ### python destination

  set( PYTHON_SITE "${INSTALL_LIB_DIR}/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages" )
  set( PYTHON_DEST "${PYTHON_SITE}/Magics" )

  file( RELATIVE_PATH relative_rpath "${CMAKE_INSTALL_PREFIX}/${PYTHON_DEST}" "${${PNAME}_FULL_INSTALL_LIB_DIR}" )

  #debug_var( relative_rpath )

  # See comment below, where the following lines are overriden
  ecbuild_append_to_rpath( ${relative_rpath} )
  ecbuild_append_to_rpath( "../../lib" ) # for the ctest to find magics libs

  ### place in build tree so we can run python tests

  configure_file( macro.py    macro.py    COPYONLY )
  configure_file( metgram.py  metgram.py  COPYONLY )

  ### build python bindings

  configure_file( Magics.i.in  Magics.i )

  include_directories( ${PYTHON_INCLUDE_DIRS} ${NUMPY_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR} )

  set_source_files_properties( ${CMAKE_CURRENT_BINARY_DIR}/Magics.i PROPERTIES GENERATED TRUE CXX ON )

  swig_add_module( Magics python Magics_interface.cc ${CMAKE_CURRENT_BINARY_DIR}/Magics.i )

  set_source_files_properties(partio.i PROPERTIES SWIG_FLAGS "-includeall")

  swig_link_libraries( Magics MagPlus ${PYTHON_LIBRARIES} )

  execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR}/Magics.py ${CMAKE_CURRENT_BINARY_DIR}/__init__.py )

  # On the MAC, only one RPATH cat be set (Mac does not understand path:path:path)
  # Someone, please fix
  # set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
  set_target_properties(_Magics PROPERTIES INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

  ### make it available in the build dir

  file( MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/${PYTHON_SITE} )

  execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_BINARY_DIR}/${PYTHON_DEST} )

  ### install to final destination

  install( TARGETS _Magics DESTINATION ${PYTHON_DEST} )
  install( FILES
               macro.py
               metgram.py
           DESTINATION ${PYTHON_DEST} )

  install( FILES  ${CMAKE_CURRENT_BINARY_DIR}/Magics.py
           RENAME __init__.py
           DESTINATION ${PYTHON_DEST} )

endif()

=== src/params/CMakeLists.txt ===
list( APPEND _common_xmls
Akima474Method.xml
Akima760Method.xml
ArrowPlotting.xml
AutomaticContourMethod.xml
Axis.xml
AxisMethod.xml
Bar.xml
BaseDriver.xml
BinaryDriver.xml
BinaryObject.xml
BinningObject.xml
BothValuePlotMethod.xml
Boundaries.xml
CalculateColourTechnique.xml
CalculateHeightTechnique.xml
CalmIndicator.xml
CartesianTransformation.xml
CellShading.xml
CircleOriginMarker.xml
Cities.xml
ClassicMtgDecoder.xml
CoastPlotting.xml
Coastlines.xml
ColourTechnique.xml
ContinuousLegendMethod.xml
Contour.xml
ContourMethod.xml
CountSelectionType.xml
Curve.xml
CurveArea.xml
DateAxisMethod.xml
DateGribLoopStep.xml
DotGraphShadeStyle.xml
DotOriginMarker.xml
DotPolyShadingMethod.xml
DumpShading.xml
FlagPlotting.xml
FortranRootSceneNode.xml
FortranSceneNode.xml
FortranViewNode.xml
GeoPointsDecoder.xml
GeoRectangularProjection.xml
Graph.xml
GraphArrow.xml
GraphFlag.xml
GraphPlotting.xml
GraphShade.xml
GraphShadeStyle.xml
GridPlotting.xml
GridShading.xml
HatchGraphShadeStyle.xml
HatchPolyShadingMethod.xml
HeightTechnique.xml
HiLo.xml
HiLoBase.xml
HiLoBoth.xml
HiLoMarker.xml
HiLoMarkerBase.xml
HiLoNumber.xml
HiLoTechnique.xml
HiLoText.xml
HighHiLo.xml
Histogram.xml
HistogramLegendMethod.xml
HyperAxisMethod.xml

ImportAction.xml

ImportPlot.xml
InputData.xml
LogoPlotting.xml
NoLogoPlotting.xml
IntervalSelectionType.xml
IsoHighlight.xml
IsoLabel.xml
IsoPlot.xml
IsoShading.xml
KMLDriver.xml
GeoJsonDriver.xml
LabelPlotting.xml

ObsPlotting.xml

LegendMethod.xml
LegendVisitor.xml

LevelListSelectionType.xml
LevelSelection.xml
ListColourTechnique.xml
ListHeightTechnique.xml
LogarithmicAxisMethod.xml

LookupTableMode.xml
LowHiLo.xml
MagnifierVisitor.xml
MapGenDecoder.xml
MarkerShadingTechnique.xml
MarkerValuePlotMethod.xml
MercatorProjection.xml
MetaData.xml

MvRootSceneNode.xml
NoBinningObject.xml
NoBoundaries.xml
NoCalmIndicator.xml
NoCities.xml
NoCoastPlotting.xml
NoGraphShade.xml
NoGridPlotting.xml
NoHiLo.xml
NoHiLoMarker.xml
NoIsoHighlight.xml
NoIsoLabel.xml
NoIsoPlot.xml
NoIsoShading.xml
NoLabelPlotting.xml
#NoLegendVisitor.xml
NoLogoPlotting.xml
NoMagnifierVisitor.xml
NoOriginMarker.xml
NoOutLayerTechnique.xml
NoPageID.xml
NoPreviewVisitor.xml
NoValuePlot.xml

OriginMarker.xml
OutputHandler.xml
PageID.xml
ParamGribLoopStep.xml
PolarStereographicProjection.xml
PolyShadingMethod.xml
PolyShadingTechnique.xml
PositionListAxisMethod.xml
PostScriptDriver.xml
PreviewVisitor.xml

Proj4Bonne.xml
Proj4Collignon.xml
Proj4EPSG32661.xml
Proj4EPSG4326.xml
Proj4EPSG3857.xml
Proj4Geos.xml
Proj4Goode.xml
Proj4Lambert.xml
Proj4Mollweide.xml
Proj4PolarNorth.xml
Proj4Projection.xml
Proj4Robinson.xml
Proj4Google.xml
Proj4Efas.xml
Proj4LambertNorthAtlantic.xml
Proj4Meteosat0.xml
Proj4Meteosat145.xml
Proj4Meteosat57.xml
Proj4Geosw.xml
Proj4Geose.xml

SDWindMode.xml
SVGDriver.xml
SampleContourMethod.xml
ImportObjectHandler.xml

SelectionMode.xml
ShadingTechnique.xml
ShapeDecoder.xml
SimpleOutLayerTechnique.xml

SymbolAdvancedTableMode.xml
SymbolIndividualMode.xml
SymbolInput.xml
SymbolMode.xml
SymbolPlotting.xml
SymbolTableMode.xml
Streamlines.xml
TableDecoder.xml
TaylorGrid.xml
TaylorProjection.xml
TextVisitor.xml
Tephigram.xml
TephiGrid.xml
TephiInfo.xml
TitleTemplate.xml
Transformation.xml
UVWindMode.xml
UserLogoPlotting.xml
VDWindMode.xml
ValuePlot.xml
ValuePlotBase.xml
ValuePlotMethod.xml
Wind.xml
WindMode.xml
WindPlotting.xml
ObsDecoder.xml
XCoordinate.xml
XDateCoordinate.xml
XHyperCoordinate.xml
XLogarithmicCoordinate.xml
XRegularCoordinate.xml
XYList.xml
GeoJSon.xml
YCoordinate.xml
YDateCoordinate.xml
YHyperCoordinate.xml
YLogarithmicCoordinate.xml
YRegularCoordinate.xml


)


	list( APPEND _magics_xmls BoxPlotBox.xml
		BoxPlotBoxBorder.xml
		BoxPlotDecoder.xml
		BoxPlotMedian.xml
		BoxPlotVisualiser.xml
		BoxPlotWhiskerBorder.xml
		BoxPlotWhiskerBox.xml
		BoxPlotWhiskerLine.xml
		CdfGraph.xml
		EpsCloud.xml
		EpsDirection.xml
		EpsGraph.xml
		EpsPlume.xml
		EpsShade.xml
		EpsWave.xml
		EpsWind.xml
		EpsXmlInput.xml
		EpsgramDecoder.xml
		EquidistantTableMode.xml
		FixedTableMode.xml
		
		EfiDataDecoder.xml
		EfiGraph.xml
		EfiJSon.xml
		EfigramDecoder.xml
		EpsBufr.xml
		ImageCalculateColourTechnique.xml
ImageListColourTechnique.xml
ImagePlotting.xml
InputMatrix.xml
InputMatrixIrregularInterpretor.xml
InputMatrixRegularInterpretor.xml
LandgramBox.xml
LandgramDecoder.xml
MetgramCurve.xml
MetgramFlags.xml
MetgramGraph.xml
MetgramBar.xml

ObsTable.xml
ObsJSon.xml

ObsStatDecoder.xml

SimplePolyline.xml
SimplePolylineInput.xml
WrepJSon.xml

WrepRootNode.xml
XmlBasicNode.xml
XmlRootNode.xml
XmlSceneNode.xml
XmlViewNode.xml
		)
	

if( HAVE_GRIB )
	list( APPEND _common_xmls GribAddressByteMode.xml
		GribAddressMode.xml
		GribAddressRecordMode.xml
		GribLoop.xml
		GribLoopStep.xml 
		GribDecoder.xml
		
		)		
endif()

if( HAVE_NETCDF )
	list( APPEND _common_xmls 
		NetcdfDecoder.xml
		NetcdfGeoMatrixInterpretor.xml
		NetcdfGeoPolarMatrixInterpretor.xml
		NetcdfGeoVectorInterpretor.xml
		NetcdfGeopointsInterpretor.xml
		NetcdfInterpretor.xml
		NetcdfMatrixInterpretor.xml
		NetcdfOrcaInterpretor.xml
		NetcdfVectorInterpretor.xml
		NetcdfXYpointsInterpretor.xml )
endif()

if ( HAVE_ODB )
	list ( APPEND _common_xmls 
		OdaGeoDecoder.xml
		OdaXYDecoder.xml )
endif()

if( HAVE_CAIRO )
    list( APPEND _common_xmls CairoDriver.xml )
endif()

if( MAGICS_RASTER )
  list( APPEND _common_xmls GDDriver.xml )
endif()

if( MAGICS_QT )
  list( APPEND  _magics_xmls QtDriver.xml )
endif()

foreach( file ${_common_xmls} )
  list( APPEND metview_xmls params/${file} )
  list( APPEND magics_xmls params/${file} )
endforeach()

foreach( file ${_magics_xmls} )
  list( APPEND magics_xmls params/${file} )
endforeach()


set( magics_xmls ${magics_xmls} PARENT_SCOPE )
set( metview_xmls ${metview_xmls} PARENT_SCOPE )

add_metview_definition_file(FILE ImportObjectHandler.xml  BASENAME MIMPORT   ACTION MIMPORT)

add_metview_definition_file(FILE Contour.xml  BASENAME MCONT   ACTION MCONT)
add_metview_definition_file(FILE SymbolPlotting.xml  BASENAME MSYMB ACTION   MSYMB)
add_metview_definition_file(FILE Coastlines.xml      BASENAME MCOAST  ACTION MCOAST)
add_metview_definition_file(FILE LegendVisitor.xml          BASENAME MLEGEND ACTION MLEGEND)
add_metview_definition_file(FILE Wind.xml            BASENAME MWIND   ACTION MWIND)
add_metview_definition_file(FILE GraphPlotting.xml   BASENAME MGRAPH  ACTION MGRAPH)
add_metview_definition_file(FILE TextVisitor.xml     BASENAME MTEXT   ACTION MTEXT)
add_metview_definition_file(FILE Axis.xml            BASENAME MAXIS   ACTION MAXIS)
add_metview_definition_file(FILE BinningObject.xml   BASENAME BinningObject  ACTION MBINNING)
add_metview_definition_file(FILE TephiGrid.xml   BASENAME MTHERMOGRID  ACTION MTHERMOGRID)
add_metview_definition_file(FILE ObsPlotting.xml   BASENAME ObsPlotting  ACTION MOBS)

=== debian/changelog ===
magics++ (2.29.2-1) unstable; urgency=medium

  * New upstream release
   - compile_fixes.patch merged upstream
   - g++-6.patch merged upstream
  * Fix python3 support: indentation errors in macro.py. Closes: #827850.
  * Loosen the libemos-dev depends, to allow backports
  * Set LC_ALL=C during build to aid reproducibility
  * Undo g++ changes for now. Closes: #830467.

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 08 Jul 2016 22:28:12 +0100

=== debian/control ===
Source: magics++
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper  (>= 9) , dh-buildinfo, gfortran, cmake, chrpath,
 dh-python,  swig,
 python-all-dev, python-numpy, 
 python3-all-dev, python3-numpy,
 libhdf5-serial-dev | libhdf5-dev, libnetcdf-dev, libnetcdf-cxx-legacy-dev,
 libgl1-mesa-dev, libgd-dev, 
 libemos-dev (>=  2:4.3.9), libgeotiff-dev,
 libgrib-api-dev (>= 1.14.5-2), libgrib-api-tools, libaec-dev,
 libterralib-dev, 
 libcairo2-dev, libpango1.0-dev,
 ttf-dejavu-core, libxml-parser-perl, 
 ghostscript, zlib1g-dev, libboost-dev, libproj-dev, 
 qtbase5-dev-tools, qtbase5-dev, qt5-qmake
Standards-Version: 3.9.8
Homepage: https://software.ecmwf.int/wiki/display/MAGP/Magics
Vcs-Git: git://anonscm.debian.org/debian-science/packages/magics.git

Package: libmagplus3v5
Section: libs
Architecture: any
Multi-Arch: same
Depends: libmagics++-data,${misc:Depends}, ${shlibs:Depends}, ttf-dejavu-core, ttf-dejavu-extra, ghostscript
Description: ECMWF meteorological plotting software library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 The library supports the plotting of contours, wind fields, observations,
 satellite images, symbols, text, axis and graphs (including boxplots).
 .
 Data fields to be plotted may be presented in various formats,
 for instance GRIB 1 and 2 code data, Gaussian grid, regularly spaced grid
 and fitted data. Input data can also be in BUFR and NetCDF format
 or retrieved from an ODB database.
 .
 The produced meteorological plots can be saved in various formats,
 such as PostScript, EPS, PDF, GIF, PNG, SVG and KML.

Package: libmagics++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${python:Depends}, libterralib-dev, magics++
Recommends: pkg-config
Description: Development files for ECMWF  plotting software MAGICS++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package includes the header files and static libraries needed to build 
 against libmagics++.

Package: magics++
Architecture: any
Multi-Arch: foreign
Depends: libmagplus3v5 ( = ${binary:Version} ),
 ${misc:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh,
 ${python:Depends}
Description: Executables for the magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 Besides its programming interfaces (Fortran and C), Magics++ offers MagML,
 a plot description language based on XML aimed at automatic web production.
 .
 This package contains the MagcML binary that may be used with magics++.

Package: python-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python, python-simplejson
Description: python support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides python support for the magics++ library.

Package: python3-magics++
Section: python
Architecture: any
Depends:  libmagplus3v5 ( = ${binary:Version} ), ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-simplejson
Description: Python3 support for Magics++
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package provides Python3 support for the magics++ library.

Package: libmagics++-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Data files needed for magics++ library
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package contains data expected by the magics++ library.


Package: libmagics++-metview-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmagplus3v5 ( = ${binary:Version} )
Description: Libraries needed for building MetView
 Magics++ is the latest generation of the ECMWF's Meteorological plotting
 software MAGICS. Although completely redesigned in C++, it is intended to be
 as backwards-compatible as possible with the Fortran interface.
 .
 This package includes the header files and static libraries needed to build
 metview against magics++.

## magics++ 2.29.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -64,9 +64,8 @@
 ecbuild_add_option( FEATURE ODB
                     DEFAULT ON
                     DESCRIPTION "ODB support"
-                    REQUIRED_PACKAGES 
-            "PROJECT odb_api VERSION 0.10.2"
-						"PROJECT eckit   VERSION 0.9.0" )
+                    REQUIRED_PACKAGES "PROJECT odb_api VERSION 0.10.2")
+					#	"PROJECT eckit   VERSION 0.9.0" )
 
 ecbuild_add_option( FEATURE CAIRO
                     DEFAULT ON

=== src/params/CMakeLists.txt ===
--- 
+++ 
@@ -136,6 +136,7 @@
 PreviewVisitor.xml
 
 Proj4Bonne.xml
+Proj4Mercator.xml
 Proj4Collignon.xml
 Proj4EPSG32661.xml
 Proj4EPSG4326.xml

=== src/visualisers/CMakeLists.txt ===
set( _visualisers_srcs
Akima760.cc
Akima760Method.h
Akima474.cc
Akima474Method.h
ArrowPlotting.cc
ArrowPlotting.h
AutomaticContourMethod.h
Axis.cc
Axis.h
AxisControl.cc
AxisControl.h
AxisItem.cc
AxisItem.h
AxisLine.h
AxisMethod.cc
AxisMethod.h
AxisType.cc
AxisType.h
Bar.cc
Bar.h
BothValuePlotMethod.h
Boundaries.cc
Boundaries.h
BoxPlotBasicItem.h
BoxPlotItem.cc
BoxPlotItem.h
BoxPlotVisualiser.cc
BoxPlotVisualiser.h
CalculateColourTechnique.cc
CalculateColourTechnique.h
CalcStreamlines.cc  
CalcStreamlines.h
CalmIndicator.h
CellShading.cc
CellShading.h
Cities.cc
Cities.h
CoastPlotting.cc
CoastPlotting.h
Coastlines.cc
Coastlines.h
ColourSelection.cc
ColourSelection.h
ColourTechnique.cc
ColourTechnique.h
Contour.cc
Contour.h
ContourLibrary.cc
ContourLibrary.h
ContourMethod.h
CountSelectionType.cc
CountSelectionType.h
Curve.cc
Curve.h
DateAxis.cc
DateAxis.h
DefinitionTable.h
DefinitionTable.hcc
DotPolyShadingMethod.h
EpsForecastPlot.h
EpsGraph.cc
EpsGraph.h
EquidistantTableMode.cc
EquidistantTableMode.h
Filter.cc
Filter.h
FlagPlotting.cc
FlagPlotting.h
FloatSelection.cc
FloatSelection.h
Graph.h
GraphPlotting.cc
GraphPlotting.h
GraphShade.cc
GraphShade.h
GraphShadeStyle.cc
GraphShadeStyle.h
GribTables.h
GridPlotting.cc
GridPlotting.h
HatchPolyShadingMethod.h
HeightSelection.cc
HeightSelection.h
HeightSelectionCount.h
HeightSelectionList.h
HeightTechnique.cc
HeightTechnique.h
HiLo.cc
HiLo.h
HiLoBase.h
HiLoBoth.h
HiLoMarker.h
HiLoMarkerBase.h
HiLoNumber.h
HiLoText.h
HiLoTechnique.h
HistoIndividualMode.h
HistoMode.h
HistoTableMode.h
Histogram.cc
Histogram.h
ImageCalculateColourTechnique.h
ImageListColourTechnique.h
ImportPlot.h
IntervalSelectionType.cc
IntervalSelectionType.h
Intervals.h
IsoHelper.cc
IsoHelper.h
IsoHighlight.h
IsoLabel.cc
IsoLabel.h
IsoPlot.cc
IsoPlot.h
IsoShading.cc
IsoShading.h
LabelPlotting.cc
LabelPlotting.h
LabelPlottingBase.h
LegendMethod.cc
LegendMethod.h
LevelListSelectionType.cc
LevelListSelectionType.h
LevelSelection.cc
LevelSelection.h
LinearTableMode.cc
LinearTableMode.h
ListColourTechnique.cc
ListColourTechnique.h
LookupTableMode.cc
LookupTableMode.h
MarkerSelection.h
MarkerSelectionCount.h
MarkerSelectionList.h
MarkerShadingTechnique.cc
MarkerShadingTechnique.h
MarkerValuePlotMethod.h
MetgramGraph.cc
MetgramGraph.h
MetgramStyle.cc
MetgramStyle.h
NormalTableMode.cc
NormalTableMode.h
ObsItem.h
ObsItemFamily.cc
ObsItemFamily.h
ObsPlotting.cc
ObsPlotting.h
ObsTable.cc
ObsTable.h
OriginMarker.h
OutLayerTechnique.cc
OutLayerTechnique.h
PolyShadingMethod.cc
PolyShadingMethod.h
PolyShadingTechnique.cc
PolyShadingTechnique.h
ShadingTechnique.h
SegmentJoiner.h
SegmentJoiner.cc
SimplePolylineVisualiser.cc
SimplePolylineVisualiser.h
Streamlines.h
Streamlines.cc
SymbolAdvancedTableMode.cc
SymbolAdvancedTableMode.h
SymbolMode.cc
SymbolMode.h
SymbolPlotting.cc
SymbolPlotting.h
TaylorGrid.cc
TaylorGrid.h
TephiGrid.cc  
TephiGrid.h
TextOrientation.cc
TextOrientation.h
UserDate.cc
UserDate.h
ValuePlot.cc
ValuePlot.h
ValuePlotBase.h
ValuePlotMethod.h
VisDefInfo.cc
VisDefInfo.h
Wind.cc
Wind.h
WindPlotting.cc
WindPlotting.h
)

foreach( file ${_visualisers_srcs} )
  list( APPEND visualisers_srcs visualisers/${file} )
endforeach()

set( visualisers_srcs ${visualisers_srcs} PARENT_SCOPE )

if ( metview )
    list (APPEND metview_include 
            visualisers/LegendMethod.h      
            visualisers/LookupTableMode.h
            )
    set( metview_include ${metview_include} PARENT_SCOPE )
endif()

=== debian/changelog ===
magics++ (2.29.4-1) unstable; urgency=medium

  * New upstream release
  * DH_COMPAT, debhelper 10
  * Re-enable unique_ptr patch for g++6

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Sep 2016 23:12:03 +0100

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# To enable all, uncomment following line
# DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-pie
CXXFLAGS:= -fPIC $(shell dpkg-buildflags --get CXXFLAGS) # -std=c++14
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# Set for build reproducibility
LC_ALL=C
export LC_ALL

export QT_SELECT=5

LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmagplus3v5.links libmagics++-dev.links libmagplus3v5.install
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --parallel --with python2,python3 --with-buildsystem=cmake

# To fix cmake output change these
OLD_GF_PATH=$(shell gfortran -print-search-dirs | grep install | cut -f2 -d' '  )libgfortran.so
NEW_GF_PATH:=$(LIBDIR)/libgfortran.so.3

export extra_flags +=  \
	-DCMAKE_PREFIX_PATH=${LIBDIR}/cmake/grib_api \
	-DBUILD_SITE=debian \
	-DENABLE_LIBGD=1 \
	-DHAVE_BOOST=1 \
	-DHAVE_DLFCN_H=1 \
	-DHAVE_INTTYPES_H=1 \
	-DHAVE_LIBEXPAT=1 \
	-DHAVE_LIBGRIB_API=1 \
	-DHAVE_LIBPROJ=1 \
	-DHAVE_LIBPTHREAD=1 \
	-DHAVE_LIBZ=1 \
	-DHAVE_MEMORY_H=1 \
	-DHAVE_STDINT_H=1 \
	-DHAVE_STDLIB_H=1 \
	-DHAVE_STRINGS_H=1 \
	-DHAVE_STRING_H=1 \
	-DHAVE_SYS_STAT_H=1 \
	-DHAVE_STS_TYPES_H=1 \
	-DHAVE_UNISTD_H=1 \
	-DMAGICS_ALLHEADERS=1 \
	-DMAGICS_GRIB=1 \
	-DMAGICS_JSON=1 \
	-DMAGICS_METVIEW=1 \
	-DMAGICS_GIF=1 \
	-DMAGICS_GIF_ANIMATED=1 \
	-DMAGICS_TIFF=1 \
	-DMAGICS_TTF=1 \
	-DMAGICS_TTF_PATH="share/magics/ttf/" \
	-DMAGICS_SITE="debian" \
	-DMAGICS_PYTHON=1 \
	-DMAGICS_THREADS=1 \
	-DDISABLE_OS_CHECK=ON \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DENABLE_FORTRAN=ON \
	-DENABLE_LARGE_FILE_SUPPORT=ON \
	-DENABLE_PYTHON=ON \
	-DBUILD_EXAMPLES=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DENABLE_TESTS=ON \
	-DENABLE_GEOTIFF=ON \
	-DENABLE_RPATHS=OFF \
	-DENABLE_CAIRO=ON \
	-DENABLE_BUFR=ON \
	-DENABLE_GRIB=ON \
	-DENABLE_METVIEW=ON \
	-DENABLE_QT5=ON \
	-DENABLE_NETCDF=ON \
	-DCMAKE_CXX_FLAGS='$(CXXFLAGS) -I/usr/include/terralib -I/usr/include/terralib/kernel -I/usr/include/geotiff' \
	-DMAGICS_EXTRA_LIBRARIES='-lterralib -lgd -lemosR64' 

export LD_LIBRARY_PATH:=$(CURDIR)/debian/tmp/usr/lib:$(LD_LIBRARY_PATH)

override_dh_auto_clean:
	rm -rf debian/build-py*
	find . -type l -delete
	rm -f src/params/*.h src/decoders/*Attributes.h
	rm -rf share/magics/ttf src/terralib debian/build
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})

override_dh_auto_configure:
	# link for font for tesing.
	mkdir -p share/fonts/truetype/ttf-dejavu/
	ln -sf /usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf share/fonts/truetype/ttf-dejavu/
	# Link terralib
	[ -e src/terralib ] || ln -sf  /usr/include/terralib src/terralib
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure --builddirectory=debian/build-py3 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python3 \
	       	$(extra_flags) 
	dh_auto_configure --builddirectory=debian/build-py2 -- \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
	       	$(extra_flags) 
	(cd python/Magics && ln -s $(CURDIR)/debian/build-py3/python/Magics/Magics.i )

override_dh_auto_build:
	dh_auto_build  --builddirectory=debian/build-py2
	dh_auto_build  --builddirectory=debian/build-py3

override_dh_auto_test check:
	# echo "Tests disabled; see README-testfailures.txt for details"
	# (ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py2/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py2  check )
	#(ulimit -s 8192; export PYTHONPATH=$(CURDIR)/debian/build-py3/python/Magics ; \
	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )

override_dh_auto_install:
	$(MAKE) -C debian/build-py3/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python3.5 \
			DESTDIR=$(CURDIR)/debian/python3-magics++ \ MAGPLUS_HOME=$(CURDIR) 
	$(MAKE) -C debian/build-py2/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python2.7 \
			DESTDIR=$(CURDIR)/debian/python-magics++ \ MAGPLUS_HOME=$(CURDIR) 
	dh_auto_install --builddirectory=debian/build-py3
	# Move lib stuff
	mkdir -p debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/*.a debian/tmp/usr/lib/pkgconfig debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libMagPlus.so debian/tmp/$(LIBDIR)/libMagPlus.so.3.0.0
	# Fixup the cmake files.
	mkdir -p debian/tmp/$(LIBDIR)/cmake/magics
	cp -a debian/tmp/usr/share/magics/cmake/* debian/tmp/$(LIBDIR)/cmake/magics
	sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%' \
		< debian/tmp/usr/share/magics/cmake/magics-targets-none.cmake \
	| sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%' \
	| sed -e 's%$(OLD_GF_PATH)%$(NEW_GF_PATH)%'   \
		> debian/tmp/$(LIBDIR)/cmake/magics/magics-targets-none.cmake
	rm -r debian/tmp/usr/share/magics/cmake
	dh_python2 /usr/lib/python2.7/site-packages/Magics
	dh_python3 /usr/lib/python3*/site-packages/Magics
	dh_numpy -p python-magics++
	dh_numpy3 -p python3-magics++
	find debian/tmp debian/python*-magics++   -name '*.so*' -exec chrpath -d {} \;
	-find debian/tmp/usr/bin -type f  -exec chrpath -d {} \;

## magics++ 2.29.6

=== debian/changelog ===
magics++ (2.29.6-2build1) zesty; urgency=medium

  * Rebuild against new libproj12.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 17 Nov 2016 14:42:32 +0100

magics++ (2.29.6-2) unstable; urgency=medium

  * Convert ksh scripts to bash

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 10 Nov 2016 23:47:11 +0000

magics++ (2.29.6-1) unstable; urgency=medium

  * New upstream release
  * DH_COMPAT, debhelper 10

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 01 Nov 2016 18:07:25 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper  (>= 9) , dh-buildinfo, gfortran, cmake, chrpath,
+Build-Depends: debhelper  (>= 10) , dh-buildinfo, gfortran, cmake, chrpath,
  dh-python,  swig,
  python-all-dev, python-numpy, 
  python3-all-dev, python3-numpy,
@@ -62,8 +62,7 @@
 Architecture: any
 Multi-Arch: foreign
 Depends: libmagplus3v5 ( = ${binary:Version} ),
- ${misc:Depends}, ${shlibs:Depends}, ksh | mksh | pdksh | zsh,
- ${python:Depends}
+ ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
 Description: Executables for the magics++ library
  Magics++ is the latest generation of the ECMWF's Meteorological plotting
  software MAGICS. Although completely redesigned in C++, it is intended to be

=== debian/rules ===
--- 
+++ 
@@ -82,6 +82,7 @@
 
 override_dh_auto_clean:
 	rm -rf debian/build-py*
+	rm -f bin/magjsonx  bin/magmlx  bin/metgramx
 	find . -type l -delete
 	rm -f src/params/*.h src/decoders/*Attributes.h
 	rm -rf share/magics/ttf src/terralib debian/build
@@ -116,10 +117,8 @@
 	#	export MAGPLUS_HOME=$(CURDIR) ; $(MAKE) -C debian/build-py3  check )
 
 override_dh_auto_install:
-	$(MAKE) -C debian/build-py3/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python3.5 \
-			DESTDIR=$(CURDIR)/debian/python3-magics++ \ MAGPLUS_HOME=$(CURDIR) 
-	$(MAKE) -C debian/build-py2/python/Magics clean install PYTHON_INCLUDE_DIR=/usr/include/python2.7 \
-			DESTDIR=$(CURDIR)/debian/python-magics++ \ MAGPLUS_HOME=$(CURDIR) 
+	(cd  debian/build-py2/python && python2 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
+	(cd  debian/build-py3/python && python3 ./setup.py install --prefix=$(CURDIR)/debian/tmp/usr )
 	dh_auto_install --builddirectory=debian/build-py3
 	# Move lib stuff
 	mkdir -p debian/tmp/$(LIBDIR)
